<h1 id="rb-inotify">rb-inotify</h1>
<p>This is a simple wrapper over the <a href="http://en.wikipedia.org/wiki/Inotify">inotify</a> Linux kernel subsystem for monitoring changes to files and directories. It uses the <a href="http://wiki.github.com/ffi/ffi">FFI</a> gem to avoid having to compile a C extension.</p>
<p><a href="http://rdoc.info/projects/nex3/rb-inotify">API documentation is available on rdoc.info</a>.</p>
<p><a href="http://travis-ci.org/guard/rb-inotify"><img src="https://secure.travis-ci.org/guard/rb-inotify.svg" alt="Build Status" /></a> <a href="https://codeclimate.com/github/guard/rb-inotify"><img src="https://codeclimate.com/github/guard/rb-inotify.svg" alt="Code Climate" /></a> <a href="https://coveralls.io/r/guard/rb-inotify"><img src="https://coveralls.io/repos/guard/rb-inotify/badge.svg" alt="Coverage Status" /></a></p>
<h2 id="basic-usage">Basic Usage</h2>
<p>The API is similar to the inotify C API, but with a more Rubyish feel. First, create a notifier:</p>
<pre><code>notifier = INotify::Notifier.new</code></pre>
<p>Then, tell it to watch the paths you’re interested in for the events you care about:</p>
<pre><code>notifier.watch(&quot;path/to/foo.txt&quot;, :modify) {puts &quot;foo.txt was modified!&quot;}
notifier.watch(&quot;path/to/bar&quot;, :moved_to, :create) do |event|
  puts &quot;#{event.name} is now in path/to/bar!&quot;
end</code></pre>
<p>Inotify can watch directories or individual files. It can pay attention to all sorts of events; for a full list, see <a href="http://www.tin.org/bin/man.cgi?section=7&amp;topic=inotify">the inotify man page</a>.</p>
<p>Finally, you get at the events themselves:</p>
<pre><code>notifier.run</code></pre>
<p>This will loop infinitely, calling the appropriate callbacks when the files are changed. If you don’t want infinite looping, you can also block until there are available events, process them all at once, and then continue on your merry way:</p>
<pre><code>notifier.process</code></pre>
<h2 id="advanced-usage">Advanced Usage</h2>
<p>Sometimes it’s necessary to have finer control over the underlying IO operations than is provided by the simple callback API. The trick to this is that the {INotify::Notifier#to_io Notifier#to_io} method returns a fully-functional IO object, with a file descriptor and everything. This means, for example, that it can be passed to <code>IO#select</code>:</p>
<pre><code> # Wait 10 seconds for an event then give up
 if IO.select([notifier.to_io], [], [], 10)
   notifier.process
 end</code></pre>
<p>It can even be used with EventMachine:</p>
<pre><code> require &#39;eventmachine&#39;

 EM.run do
   EM.watch notifier.to_io do
     notifier.process
   end
 end</code></pre>
<p>Unfortunately, this currently doesn’t work under JRuby. JRuby currently doesn’t use native file descriptors for the IO object, so we can’t use the notifier’s file descriptor as a stand-in.</p>
<h2 id="contributing">Contributing</h2>
<ol type="1">
<li>Fork it</li>
<li>Create your feature branch (<code>git checkout -b my-new-feature</code>)</li>
<li>Commit your changes (<code>git commit -am 'Add some feature'</code>)</li>
<li>Push to the branch (<code>git push origin my-new-feature</code>)</li>
<li>Create new Pull Request</li>
</ol>
<h2 id="license">License</h2>
<p>Released under the MIT license.</p>
<p>Copyright, 2009, by <a href="https://github.com/nex3">Natalie Weizenbaum</a>. Copyright, 2017, by <a href="http://www.codeotaku.com/samuel-williams">Samuel G. D. Williams</a>.</p>
<p>Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the “Software”), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:</p>
<p>The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.</p>
<p>THE SOFTWARE IS PROVIDED “AS IS”, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.</p>
